# distcc.spec: v32 2009/06/10 KELEMEN Peter <lxdistcc-admins@cern.ch>

%define version	3.1
%define release 18cern.svn20090608

%{!?dist: %define dist .slc5}

%define	_prefix	/usr
%define _bindir %{_prefix}/bin
%define _datadir %{_prefix}/share
#%define _docdir %{_datadir}/doc/%{name}-%{version}
%define _docdir %{_datadir}/doc/%{name}
%define _libdir %{_prefix}/%{_lib}
%define _mandir %{_datadir}/man
%define _sysconfdir /etc

Name: distcc
Summary: Program for distributed C/C++ compilations.
Version: %{version}
Release: %{release}%{?dist}
Group: Development/Languages
Url: https://code.google.com/p/distcc
License: GPL
Packager: KELEMEN Peter <lxdistcc-admins@cern.ch>
Distribution: Scientific Linux CERN
BuildArch: x86_64
BuildRoot: %{_tmppath}/%{name}-buildroot
Prefix: %_prefix
BuildRequires: libgssapi-devel, autoconf, automake, krb5-devel, python-devel
Requires: libgssapi

#Source: http://distcc.googlecode.com/files/%{name}-%{version}.tar.gz
Source: %{name}-%{version}.svn20090608.tar.bz2
Patch01: distcc_gssapi_auth.patch
Patch02: distcc_gssapi_auth_acl.patch
Patch03: distcc_filelog_timestamp_trace.patch
Patch04: distcc_15min_timeout_io.patch
Patch05: distcc_integration_tests.patch
Patch06: distcc_gssapi_auth_protocol_doc.patch
Patch07: distcc_test.patch
Patch08: distcc_extended_summary.patch
Patch80: distcc_lxdistcc_timeouts.patch
Patch81: distcc_lxdistcc_logrotate.patch
Patch82: distcc_lxdistcc_clients_allow.patch
Patch83: distcc_lxdistcc_sysconfig.patch
Patch90: distcc_init_script.patch
Patch91: distcc_clang_support.patch

%description
distcc is a program to distribute compilation of C or C++ code across several
machines on a network. distcc should always generate the same results as a
local compile, is simple to install and use, and is often two or more times
faster than a local compile.


%prep
%setup
%patch01 -p2
%patch02 -p2
%patch03 -p2
%patch04 -p2
%patch05 -p2
%patch06 -p2
#patch07 -p2
%patch08 -p2
%patch80 -p1
%patch81 -p1
%patch82 -p1
%patch83 -p1
%patch90 -p2
%patch91 -p1

%build
# Work around broken sendfile in 32 bit apps on some x86_64 systems
./autogen.sh
ac_cv_func_sendfile=no ac_cv_header_sys_sendfile_h=no ./configure \
  --prefix=%{_prefix} \
  --bindir=%{_bindir} \
  --sysconfdir=%{_sysconfdir} \
  --datadir=%{_datadir} \
  --with-docdir=%{_docdir} \
  --mandir=%{_mandir} \
  --with-auth \
  --without-avahi \
  --enable-rfc2553 --with-included-popt
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=${RPM_BUILD_ROOT} install
# The remaining configuration files are installed here rather than by
# 'make install' because their nature and their locations are too
# system-specific.
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
install -m 644 packaging/RedHat/logrotate.d/distcc $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/distcc
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d
install -m 644 packaging/RedHat/xinetd.d/distcc $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d/distcc
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/init.d
install -m 755 packaging/RedHat/init.d/distcc $RPM_BUILD_ROOT%{_sysconfdir}/init.d/distcc
# TODO(fergus): move the next five lines to 'make install'?
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/distcc
ln -s %{_bindir}/distcc $RPM_BUILD_ROOT/%{_libdir}/distcc/cc
ln -s %{_bindir}/distcc $RPM_BUILD_ROOT/%{_libdir}/distcc/c++
ln -s %{_bindir}/distcc $RPM_BUILD_ROOT/%{_libdir}/distcc/gcc
ln -s %{_bindir}/distcc $RPM_BUILD_ROOT/%{_libdir}/distcc/g++

mv $RPM_BUILD_ROOT/%{_sysconfdir}/default $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig
rm $RPM_BUILD_ROOT/%{_bindir}/lsdistcc
rm $RPM_BUILD_ROOT/%{_mandir}/man1/include_server.1
rm $RPM_BUILD_ROOT/%{_mandir}/man1/pump.1

#slc5
rm -f ${RPM_BUILD_ROOT}/%{_bindir}/pump
rm -rf ${RPM_BUILD_ROOT}/%{_libdir}/python2.4

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root, 0755)
%{_bindir}/distcc
%{_bindir}/distccmon-text
#{_bindir}/lsdistcc
%{_libdir}/distcc
%dir %{_sysconfdir}/distcc
%config %{_sysconfdir}/distcc/hosts
%doc %{_mandir}/man1/distcc.1.gz
%doc %{_mandir}/man1/distccmon-text.1.gz
%doc %{_docdir}

%package server
Summary: Server side program for distributed C/C++ compilations.
Group: Development/Languages
Requires: libgssapi
Provides: distccd

%description server
distcc is a program to distribute compilation of C or C++ code across several
machines on a network. distcc should always generate the same results as a
local compile, is simple to install and use, and is often two or more times
faster than a local compile.

%files server
%defattr(-, root, root, 0755)
%{_bindir}/distccd
%dir %{_sysconfdir}/logrotate.d
%config %{_sysconfdir}/logrotate.d/distcc
# Don't list init.d dir because on Red Hat it's a symlink owned by
# chkconfig, so it causes a conflict on install.
#%dir %{_sysconfdir}/init.d
%config %{_sysconfdir}/init.d/distcc
%dir %{_sysconfdir}/xinetd.d/
%config %{_sysconfdir}/xinetd.d/distcc
%dir %{_sysconfdir}/distcc
%config(noreplace) %{_sysconfdir}/distcc/clients.allow
%config(noreplace) %{_sysconfdir}/distcc/commands.allow.sh
%dir %{_sysconfdir}/sysconfig
%config(noreplace) %{_sysconfdir}/sysconfig/distcc
%doc %{_mandir}/man1/distccd.1.gz

%if "%{dist}" == ".slc6"
%{_libdir}/python2.6/site-packages/*
%endif

%pre server

%post server
DISTCC_USER=distcc
if [ -s /etc/redhat-release ]; then
  # sadly, can't useradd -s /sbin/nologin on rh71, since
  # then starting the service as user distcc fails,
  # since it uses su - without overriding the shell :-(
  # See https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=26894
  /sbin/service distcc stop &>/dev/null || :
  if fgrep 'nice initlog $INITLOG_ARGS -c "su - $user' /etc/init.d/functions | fgrep -v '.-s ' > /dev/null 2>&1 ; then
    # Kludge: for Red Hat 6.2, don't use -s /sbin/nologin
    /usr/sbin/useradd -d /var/run/distcc -m -r $DISTCC_USER &>/dev/null || :
  else
    # but do for everyone else
    /usr/sbin/useradd -d /var/run/distcc -m -r -s /sbin/nologin $DISTCC_USER &>/dev/null || :
  fi
else
  echo Creating $DISTCC_USER user...
  if ! id $DISTCC_USER > /dev/null 2>&1 ; then
    if ! id -g $DISTCC_USER > /dev/null 2>&1 ; then
      addgroup --system --gid 11 $DISTCC_USER
    fi
    adduser --quiet --system --gid 11 \
      --home / --no-create-home --uid 15 $DISTCC_USER
  fi
fi

DISTCC_LOGFILE=/var/log/distccd.log
if [ ! -s $DISTCC_LOGFILE ]; then
  touch $DISTCC_LOGFILE
  chown ${DISTCC_USER}:adm $DISTCC_LOGFILE
  chmod 640 $DISTCC_LOGFILE
fi

if ! grep -q "3632/tcp" /etc/services; then
  echo -e "distcc\t\t3632/tcp\t\t\t# Distcc Distributed Compiler" >> /etc/services
fi

if ! grep -q "^distcc:" /etc/hosts.allow; then
  echo -e "distcc:\t127.0.0.1" >> /etc/hosts.allow
fi

# Update runlevel settings and start daemon.
if [ -s /etc/redhat-release ]; then
  /sbin/chkconfig --level 345 distcc on
  #/sbin/chkconfig --add distcc
  /etc/init.d/distcc start || exit 0
else
  if [ -x "/etc/init.d/distcc" ]; then
    update-rc.d -f distcc remove >/dev/null
    update-rc.d distcc defaults 95 05 >/dev/null
    if [ -x /usr/sbin/invoke-rc.d ]; then
      start_command="invoke-rc.d distcc start"
    else
      start_command="/etc/init.d/distcc start"
    fi
    $start_command || {
        echo "To enable distcc's TCP mode, you should edit these files"
        echo "        %{_sysconfdir}/distcc/clients.allow"
        echo "        %{_sysconfdir}/distcc/commands.allow.sh"
        echo "and then run (as root)"
        echo "        $start_command"
        echo "For more info, including alternatives to TCP mode, see"
        echo "%{_docdir}/INSTALL and %{_docdir}/examples/README."
    }
  fi
fi

%preun server
# Remove hosts.allow entry.
if grep -q "^distcc:" /etc/hosts.allow; then
  sed -e "/^distcc/d" /etc/hosts.allow > /etc/hosts.allow.new
  mv /etc/hosts.allow.new /etc/hosts.allow
fi

# Stop daemon and clear runlevel settings.
if [ -s /etc/redhat-release ]; then
  if [ $1 -eq 0 ]; then
    /sbin/service distcc stop &>/dev/null || :
  fi
  # chkconfig --del must run before deleting init script.
  /sbin/chkconfig --del distcc
else
  if [ -x "/etc/init.d/distcc" ]; then
    if [ -x /usr/sbin/invoke-rc.d ] ; then
      invoke-rc.d distcc stop || exit 0
    else
      /etc/init.d/distcc stop || exit 0
    fi
  fi
fi

%postun server
# TODO(mtm) Should Red Hat also remove user/group?
if [ -s /etc/debian_version ]; then
  case "$1" in
    purge)
      deluser --quiet --system distcc
      delgroup --quiet --system distcc
      ;;
    remove)
      ;;
    upgrade|failed-upgrade|abort-install|abort-upgrade|disappear)
      ;;
    *)
      echo "postrm called with unknown argument \`$1'" >&2
      exit 1
    ;;
  esac

  if [ "$1" = "purge" ] ; then
    # update-rc.d must run after deleting init script.
    update-rc.d distcc remove >/dev/null || exit 0
  fi
fi

%changelog
* Fri May 23 2014 Thomas Oulevey <lxdistcc-admins@cern.ch> 3.1-18cern.svn20090608
- Add config(noreplace) on /etc 

* Wed Feb 19 2014 Thomas Oulevey <lxdistcc-admins@cern.ch> 3.1-17cern.svn20090608
- Update tv.timeout for CERN installation

* Thu Jun 20 2013 Jan van Eldik <lxdistcc-admins@cern.ch> 3.1-16cern.svn20090608
- Add BuildRequires on krb5-devel, python-devel

* Thu Jun 20 2013 Jan van Eldik <lxdistcc-admins@cern.ch> 3.1-14cern.svn20090608
- Allow clang and clang++ compilers

* Thu Jan 13 2012 Jan van Eldik <lxdistcc-admins@cern.ch> 3.1-13cern.svn20090608
- Include CERN-specific /etc/sysconfig/distcc, /etc/distcc/clients.allow files
- server %post: Make sure chkconfig works as expected

* Thu Jan 12 2012 Jan van Eldik <lxdistcc-admins@cern.ch> 3.1-12cern.svn20090608
- Improve logrotation.

* Mon Nov 15 2010 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-11cern.svn20090608
- Increased timeouts for heavy load.

* Wed Jun 10 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-10cern.svn20090608
- Upstream SVN 20090806 with Ian's latest patches.

* Mon Apr 27 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-9cern.svn20090227
- New release with Ian's latest patches.

* Wed Mar 25 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-8cern.svn20090227
- configure --without-avahi

* Mon Mar 23 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-7cern.svn20090227
- BuildArch: x86_64
- Conditional specfile conflicts with our current build system, reverting.

* Tue Mar 17 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-6cern.svn20090227
- Conditional specfile for SLC4/SLC5.

* Mon Mar 16 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-5cern.svn20090227
- Fixed lockfile renaming regression.

* Tue Mar  3 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-4cern.svn20090227
- Packages renamed again to follow DAG/Fedora naming conventions (distcc, distcc-server).

* Tue Mar  3 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-3cern.svn20090227
- Support DISTCCD_PATH .
- Fix Kerberos V host keytab extraction.
- Fix passing KRB5_KTNAME .

* Tue Mar  3 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-2cern.svn20090227
- Bump version.

* Tue Mar  3 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-1cern.svn20090227.6
- Make /etc/srvtab processing is distribution-independent.

* Tue Mar  3 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-1cern.svn20090227.5
- Defaults to host keytab for GSSAPI.

* Tue Mar  3 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-1cern.svn20090227.4
- Init script supports passing environment variables.

* Mon Mar  2 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.1-1cern.svn20090227.3
- Updated contact address.

* Mon Mar  2 2009 KELEMEN Peter <linux-distcc@cern.ch> 3.1-1cern.svn20090227.2
- Improved support for /etc/sysconfig/distcc .

* Mon Mar  2 2009 KELEMEN Peter <linux-distcc@cern.ch> 3.1-1cern.svn20090227.1
- Added build dependencies, invoke autogen.sh in %build.
- Package name changes.

* Wed Feb 25 2009 KELEMEN Peter <lxdistcc-admins@cern.ch> 3.0-1cern1
- Initial packaging of GSSAPI-enabled version.
